config/routes.rb
Rails.application.routes.draw do
  root to: 'pages#home'
  get 'ourwork' => 'pages#ourwork', as: :ourwork
  devise_for :users
  
  resources :gfs_registrations do
    collection do
      get :gfs_terms
    end
  end
  namespace :user do
    resources :messages do
      collection do
        get :get_messages
      end
    end
    resources :tests 
    resource :dashboard, controller: :dashboard
    resources :assignments do
      member do
        post :start
        get :started
        post :next
        get :complete
        get :completed
        get :show_reviewed_test
      end
      collection do
        get :reviewed
      end
    end
  end

  namespace :staff do
    resources :messages do
      collection do
        get :get_messages
        get :get_users
      end
    end
    resources :guest_users
    resource :dashboard, controller: :dashboard do 
      collection do
        get :pending_reviews
        get :completed_reviews
      end
    end
    resources :users do
      resources :assignments do
        member do
          get :review
          put :review_feedback
        end
      end
    end
    resources :questions do
      collection do
        get :upload_file
        post :upload
      end
    end
    resources :tests do
      member do
        get :upload_file
        post :upload
        get :print
      end
      resources :sections do
        member do
          get :questions
          put :questions_update
        end
      end
    end
  end

  namespace :guest_user do
    resources :tests, only: [:show] do
      member do
        get :new_register
        post :register
        post :start
        get :started
        post :next
        get :complete
        get :completed

      end
    end
  end
  
  resources :events do
    member do
      get :register
      get :registered_users
      get :details
      get :print_qr
      get :print_reg_users
    end
    collection do
      get ':category/listing' => 'events#listing', as: :listing
    end

    resources :feedbacks, :controller => "student_feedbacks"
    resources :registrations, :controller => "event_registrations"
  end


  get '/online/:slug' => 'user/tests#register', as: :online_test
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/answer.rb
class Answer < ApplicationRecord
  belongs_to :question
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/assignment.rb
class Assignment < ApplicationRecord
  belongs_to :test
  belongs_to :user, optional: true
  #belongs_to :guest_user

  STATUSES = ['started', 'completed', 'reviewed']

  validates :due_date, presence: true

  scope :unarchived, -> {where(archived: false)}
  scope :pending, -> {where(status: nil)}
  scope :completed, -> {where(status: 'completed')}
  scope :reviewed, -> {where(status: 'reviewed')}

  def assignee
    if self.user_id.present?
      User.find self.user_id
    else
      GuestUser.find self.guest_user_id
    end
  end
end

app/models/event.rb
class Event < ApplicationRecord
  CATEGORIES = ['anthropreneur', 'job_seeker', 'general']
  FREQUENCIES = ['daily', 'weekly', 'monthly']
  DURATIONS = { 30 => '30 minutes', 40 => '40 minutes', 60 => '1 hour', 90 => '1.5 hours', 120 => '2 hours', 150 => '2.5 hours', 180 => '3 hours', 210 => '3.5 hours', 240 => '4 hours' }

  has_many :student_feedbacks
  has_many :user_events
  has_many :event_registrations

  scope :active, -> { where('event_date >= ?', Time.current.beginning_of_day) }
  scope :expired, -> { where('event_date < ?', Time.current.beginning_of_day) }

  validates :name, :event_date, :reg_end_date, :category,  presence: true

  def image_url
    image || "event_1.jpg"
  end

  def frequency_duration
    case frequency
    when 'daily'
      1.day
    when 'weekly'
      1.week
    when 'monthly'
      1.month
    end
  end
end

app/models/event_registration.rb
class EventRegistration < ApplicationRecord
  serialize :extra, JSON
  belongs_to :event
end

app/models/gfs_registration.rb
class GfsRegistration < ApplicationRecord
serialize :financial_service_intrested, JSON

validates :name, :email, :terms_conditions,  presence: true

end

app/models/guest_user.rb
class GuestUser < ApplicationRecord
  has_many :assignments
end

app/models/message.rb
class Message < ApplicationRecord
  belongs_to :sender, class_name: :User
end

app/models/question.rb
class Question < ApplicationRecord
  #CATEGORIES = ['science', 'maths', 'reasoning', 'interests']
  enum q_type: { single_answer: 0, multiple_answer: 1, theory: 2 }
  before_save :downcase_category

  has_many :answers, dependent: :destroy
  has_many :section_questions


  validates :text, presence: true
 
  def downcase_category
    self.category = self.category.downcase if self.category.present?
  end
end

app/models/result.rb
class Result < ApplicationRecord
  serialize :answers, JSON
end

app/models/section.rb
class Section < ApplicationRecord
  belongs_to :test
  has_many :section_questions

  scope :unarchived, -> { where(archived: false) }

  validates :name, presence: true
end

app/models/section_question.rb
class SectionQuestion < ApplicationRecord
  belongs_to :question
  belongs_to :section
end

app/models/student_feedback.rb
class StudentFeedback < ApplicationRecord
  belongs_to :event
  validates :name, :phone, :email, presence: true 
end

app/models/test.rb
class Test < ApplicationRecord
  DURATIONS = {15 => '15 minutes', 20 => '20 minutes', 30 => '30 minutes', 40 => '40 minutes', 60 => '60 minutes', 90 => '90 minutes', 120 => '120 minutes'}
  has_many :assignments
  has_many :sections
  has_many :section_questions, through: :sections

  validates :name, :duration, :guidelines, presence: true
  validates :slug, presence: true, uniqueness: true

  before_validation :generate_slug, on: :create

  def generate_slug
    self.slug = self.name.parameterize
    count = 0
    while Test.find_by(slug: self.slug).present?
      count++
      self.slug = self.name.parameterize + "-#{count}"
    end
  end
end

app/models/user.rb
class User < ApplicationRecord
  has_many :user_events
  has_many :assignments
  ROLES = ['staff', 'user']

  validates :name, presence: true
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable


end

app/models/user_event.rb
class UserEvent < ApplicationRecord
  belongs_to :user
  belongs_to :event
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
  layout "landing"
  
  def home
    @upcoming = Event.active.order(event_date: :asc)
    @expires = Event.expired.order(event_date: :desc)
    @events = @upcoming + @expires
  end
  
end

app/controllers/student_feedbacks_controller.rb
class StudentFeedbacksController < ApplicationController

  skip_before_action :authenticate_user!

  layout 'feedback'
  
  def new
    @feedback = StudentFeedback.new(event_id: params[:event_id])
  end

  def index
    @feedbacks = StudentFeedback.all
  end

  def create
    @feedback = StudentFeedback.new(feedback_params)
    if @feedback.save
      redirect_to event_feedback_path(@feedback.event_id, @feedback.id)
    else
      render action: 'new'
    end
  end

  def show
  end

  def destroy
    @feedback = StudentFeedback.find(params[:id])
    @feedback.destroy
    redirect_to feedbacks_path
  end
  
  private 
    def feedback_params
      params.require(:student_feedback).permit(:name, :date, :phone, :email, :program_title, :organisation, :suggestions, :top_3_things, :expirence, :implementation_on_day_to_day, :rsvp, :event_id)
    end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/events_helper.rb
module EventsHelper
end

app/helpers/guest_users_helper.rb
module GuestUsersHelper
end

app/helpers/pages_helper.rb
module PagesHelper
end

app/helpers/staff/student_feedbacks_helper.rb
module Staff::StudentFeedbacksHelper
end

app/helpers/student_feedbacks_helper.rb
module StudentFeedbacksHelper
end

app/views/student_feedbacks/index.html.erb
<% if @feedbacks.present? %>
<div>
</div>
  <table class="striped">
    <tr>
      <th>Name</th>
      <th>Phone</th>
      <th>Email</th>
      <th>Company</th>
    </tr>
    <tbody>
      <% @feedbacks.each do |f| %>
        <tr>
          <td><%= link_to f.name, feedback_path(f) %></td>
          <td><%= f.phone_no %> </td>
          <td><%= f.email %></td>
          <td><%= f.organisation %></td>
          <td><%= link_to feedback_path(f), method: :delete, data: { confirm: "You sure?"  } do %>
                                      Delete<% end %></td>
        </tr>
      <% end %>
    </tbody>
  </table>
  <% else %>
  <div style="text-align: center; background-color: #eee; padding-top: 15px;">
     no feedbacks
    <br />
    <br />
  </div>
<% end %>

app/views/student_feedbacks/new.html.erb
<div style="margin-top: 10px; margin-bottom: 10px; margin-left: 10px; margin-right: 10px;">
<%= image_tag "Ta5-logo.png", style: "max-height: 48px;max-width: 200px;" %><br/>
<hr />
<h3 style="text-align: center;"> TECH AFTER FIVE (Ta5) EVENT FEEDBACK FORM </h3>
<%= form_for @feedback,  url: event_feedbacks_path do |f| %>
  <%= f.error_messages %>
    <%= f.hidden_field :event_id %>
    <div class="feedback">
      <%= f.label :name, class: "form-lbl" do %>
        <span style="color: red;">*</span> Name 
      <% end %>
      <%= f.text_field :"name", class: "form-tf" %>
    </div>

    <div class="feedback">
      <%= f.label :phone, class: "form-lbl" do%>
        <span style="color: red;">*</span> phone 
      <% end %>
      <%= f.phone_field :phone, class: "form-tf"%>
    </div>

    <div class="feedback">
      <%= f.label :email, class: "form-lbl" do%>
        <span style="color: red;">*</span> email 
      <% end %>
      <%= f.email_field :email, class: "form-tf"%>
    </div>

    <div class="feedback">
      <%#= f.label :"Program Title :", class: "form-lbl"%>
      <%#= f.text_field :program_title, class: "form-tf"%>
    </div>

    <div class="feedback">
      <%= f.label :organization, 'Company', class: "form-lbl"%>
      <%= f.text_field :organisation, class: "form-tf" %>
    </div>


    <div style="margin-top: 10px;">
      <%#= f.label :"List 3 positive connections/experiences from Ta5 "%>
      <%#= f.text_area :top_3_things, rows: "8", class: "form-ta" %>

      <%= f.label :"List 3 positive connections/experiences from Ta5 "%>
      <%= f.text_area :expirence, rows: "8", class: "form-ta" %>

      <%= f.label :"Any suggestions to improve Ta5"%>
      <%= f.text_area :suggestions, rows: "8", class: "form-ta" %>

      <%#= f.label :"How do you implement in a day to day life? "%>
      <%#= f.text_area :implementation_on_day_to_day, rows: "8", class: "form-ta" %>

      <!--
      <%= f.label :"Will you attend the workshop?", class: "" do %>
        <span style="color: red;">*</span> Will you attend the workshop? 
      <% end %>
      <ul type="none">
      <li><%= f.radio_button :rsvp, 'yes' %>Yes </li>
      <li><%= f.radio_button :rsvp, 'no' %> No</li>
      <li><%= f.radio_button :rsvp, 'may_be' %> May be</li>
      </ul>
      -->
    </div>

    <h3 style="text-align: center;"> Thanks for attending Ta5 </h3>

   
    <div style="text-align: center;">   
      <%= f.submit "Submit", class: "btn" %>
    </div>
<% end %>


</div>

app/views/student_feedbacks/show.html.erb
Thank you for your feedback